<template>
  <div class="mt-4">
    <div>
      <b-modal ref="putmodal" hide-footer id="modal-1" title="BootstrapVue">
        <div class="form-group">
          <form method="put" @submit.prevent="putTeilnehmer(teilnehmerUpdate.id)">
            <input type="text" name="name" id="" placeholder="Name" v-model="teilnehmerUpdate.name"
              class="form-control"> <br>
            <input type="text" name="email" id="" placeholder="E-Mail" v-model="teilnehmerUpdate.eMailAdresse"
              class="form-control"> <br>
            <input type="text" name="adresse" id="" placeholder="Adresse" v-model="teilnehmerUpdate.adresse"
              class="form-control"> <br>
            <input type="text" name="telnummer" id="" placeholder="Tel-Nummer" v-model="teilnehmerUpdate.telNummer"
              class="form-control"> <br>
            <input type="text" name="startdatum" id="" placeholder="StartDatum" v-model="teilnehmerUpdate.startDatum"
              class="form-control"> <br>
            <input type="text" name="enddatum" id="" placeholder="EndDatum" v-model="teilnehmerUpdate.endDatum"
              class="form-control"> <br>
            <label for="">Gruppe wählen</label>
            <select class="form-control form-select-lg mb-3" name="TrainerAnstellung" id=""
              v-model="teilnehmerUpdate.gruppeId">
              <option v-for="(gruppe, id) in alleGruppen" :key='id' :value="gruppe.id">
                {{ gruppe.artDerAusbildung }}{{ gruppe.gruppenNummer }}</option>
            </select>
            <button type="submit" class="btn container-fluid btn-info">Speichern</button>
          </form>
        </div>

      </b-modal>
    </div>

    <table class="table">
      <th>Name</th>
      <th>e-mailAdresse</th>
      <th>Tel-Nummer</th>
      <th>Adresse</th>
      <th>Startdatum</th>
      <th>Enddatum</th>
      <th>ID</th>
      <th></th>
      <tr v-for="(person, id) in alleTeilnehmer" :key='id'>
        <td>{{ person.name }}</td>
        <td>{{ person.eMailAdresse }}</td>
        <td>{{ person.telNummer }}</td>
        <td>{{ person.adresse }}</td>
        <td>{{ person.startDatum }}</td>
        <td>{{ person.endDatum }}</td>
        <td>{{ person.id }}</td>
        <button type="button" class="btn btn-danger m-1" @click="deleteTeilnehmer(person.id)">X</button>
        <button type="button" class="btn btn-primary m-1" v-b-modal.modal-1
          @click="editTeilnehmer(person), getTeilnehmberById(person.id)">O</button>
      </tr>
    </table>
  </div>
</template>

<script>



export default {
  data() {
    return {
      modes: ["multi", "single", "range"],
      fields: ["name", "email", "telNummer", "adresse", "startDatum", "endDatum"],
      items: [],
      selectMode: "multi",
      selected: [],

      teilnehmerUpdate: {
        name: '',
        eMailAdresse: '',
        adresse: '',
        telNummer: '',
        startDatum: '',
        endDatum: '',
        gruppeId: '',
        id: ''
      }


    };
  },
  computed: {
    alleTeilnehmer() {
      return this.$store.state.alleTeilnehmer;
    },

    teilnehmberById() {
      return this.$store.state.teilnehmberById;
    },

    alleGruppen() {
      return this.$store.state.alleGruppen;
    },
  },
  methods: {
    
    async deleteTeilnehmer(id) {
      const deleteTeilnehmer = this.$store.dispatch("deleteTeilnehmer", id);
      console.log(deleteTeilnehmer);
    },

    async getTeilnehmberById(id) {
      this.$store.dispatch("getTeilnehmerById", id)
    },

    async editTeilnehmer(teilnehmberById) {
      this.teilnehmerUpdate.name = teilnehmberById.name;
      this.teilnehmerUpdate.eMailAdresse = teilnehmberById.eMailAdresse;
      this.teilnehmerUpdate.adresse = teilnehmberById.adresse;
      this.teilnehmerUpdate.telNummer = teilnehmberById.telNummer;
      this.teilnehmerUpdate.startDatum = teilnehmberById.startDatum;
      this.teilnehmerUpdate.endDatum = teilnehmberById.endDatum;
      this.teilnehmerUpdate.gruppeId = teilnehmberById.gruppeId;
      this.teilnehmerUpdate.id = teilnehmberById.id;
    },

    async putTeilnehmer() {
      console.log(this.teilnehmerUpdate)
      console.log(this.teilnehmerUpdate.id)
      this.$store.dispatch("putTeilnehmer", this.teilnehmerUpdate)
      this.hideModal();
    },

    hideModal() {
      this.$refs['putmodal'].hide();
    }


  },

  mounted() {
    this.$store.dispatch("getAlleTeilnehmer");
    this.$store.dispatch("getAlleGruppen");
  },


  components: {}
}

</script>

